// Code generated by go_code.py; DO NOT EDIT.

package clipboard
import "fmt"
import "kitty/tools/cli"
var _ = fmt.Sprintf
func create_cmd(root *cli.Command, run_func func(*cli.Command, *Options, []string)(int, error)) {
ans := root.AddSubCommand(&cli.Command{
Name: "clipboard",
ShortDescription: "Copy/paste with the system clipboard, even over SSH",
Usage: "[options] [files to copy to/from]",
HelpText: "Read or write to the system clipboard.\n\nThis kitten operates most simply in :italic:`filter mode`.\nTo set the clipboard text, pipe in the new text on :file:`STDIN`. Use the\n:option:`--get-clipboard` option to instead output the current clipboard text content to\n:file:`STDOUT`. Note that copying from the clipboard will cause a permission\npopup, see :opt:`clipboard_control` for details.\n\nFor more control, specify filename arguments. Then, different MIME types can be copied to/from\nthe clipboard. Some examples:\n\n.. code:: sh\n\n    # Copy an image to the clipboard:\n    kitten clipboard picture.png\n\n    # Copy an image and some text to the clipboard:\n    kitten clipboard picture.jpg text.txt\n\n    # Copy text from STDIN and an image to the clipboard:\n    echo hello | kitten clipboard picture.png /dev/stdin\n\n    # Copy any raster image available on the clipboard to a PNG file:\n    kitten clipboard -g picture.png\n\n    # Copy an image to a file and text to STDOUT:\n    kitten clipboard -g picture.png /dev/stdout\n\n    # List the formats available on the system clipboard\n    kitten clipboard -g -m . /dev/stdout\n",
Run: func(cmd *cli.Command, args []string) (int, error) {
opts := Options{}
err := cmd.GetOptionValues(&opts)
if err != nil { return 1, err }
return run_func(cmd, &opts, args)},
})
ans.Add(cli.OptionSpec{
            Name: "--get-clipboard -g",
            Type: "bool-set",
            Dest: "GetClipboard",
            Help: "Output the current contents of the clipboard to STDOUT. Note that by default kitty will prompt for permission to access the clipboard. Can be controlled by :opt:`clipboard_control`.",
        })
ans.Add(cli.OptionSpec{
            Name: "--use-primary -p",
            Type: "bool-set",
            Dest: "UsePrimary",
            Help: "Use the primary selection rather than the clipboard on systems that support it, such as Linux.",
        })
ans.Add(cli.OptionSpec{
            Name: "--mime -m",
            Type: "list",
            Dest: "Mime",
            Help: "The mimetype of the specified file. Useful when the auto-detected mimetype is likely to be incorrect or the filename has no extension and therefore no mimetype can be detected. If more than one file is specified, this option should be specified multiple times, once for each specified file. When copying data from the clipboard, you can use wildcards to match MIME types. For example: :code:`--mime 'text/*'` will match any textual MIME type available on the clipboard, usually the first matching MIME type is copied. The special MIME type :code:`.` will return the list of available MIME types currently on the system clipboard.",
        })
ans.Add(cli.OptionSpec{
            Name: "--alias -a",
            Type: "list",
            Dest: "Alias",
            Help: "Specify aliases for MIME types. Aliased MIME types are considered equivalent. When copying to clipboard both the original and alias are made available on the clipboard. When copying from clipboard if the original is not found, the alias is used, as a fallback. Can be specified multiple times to create multiple aliases. For example: :code:`--alias text/plain=text/x-rst` makes :code:`text/plain` an alias of :code:`text/rst`. Aliases are not used in filter mode. An alias for :code:`text/plain` is automatically created if :code:`text/plain` is not present in the input data, but some other :code:`text/*` MIME is present.",
        })
ans.Add(cli.OptionSpec{
            Name: "--wait-for-completion",
            Type: "bool-set",
            Dest: "WaitForCompletion",
            Help: "Wait till the copy to clipboard is complete before exiting. Useful if running the kitten in a dedicated, ephemeral window. Only needed in filter mode.",
        })
ans.ArgCompleter = cli.MimepatCompleter("Files", cli.CWD, "*")
}
type Options struct {
GetClipboard bool
UsePrimary bool
Mime []string
Alias []string
WaitForCompletion bool
}
func (opts Options) AsCommandLine() (ans []string) {
	 sval := ""
	 _ = sval
	sval = fmt.Sprintf(`%#v`, opts.GetClipboard)
	if (sval != `false`) { ans = append(ans, `--get-clipboard=` + sval)}
	sval = fmt.Sprintf(`%#v`, opts.UsePrimary)
	if (sval != `false`) { ans = append(ans, `--use-primary=` + sval)}
		for _, x := range opts.Mime { ans = append(ans, `--mime=` + x) }
		for _, x := range opts.Alias { ans = append(ans, `--alias=` + x) }
	sval = fmt.Sprintf(`%#v`, opts.WaitForCompletion)
	if (sval != `false`) { ans = append(ans, `--wait-for-completion=` + sval)}
return
}
