// Code generated by go_code.py; DO NOT EDIT.

package themes
import "fmt"
import "kitty/tools/cli"
var _ = fmt.Sprintf
func create_cmd(root *cli.Command, run_func func(*cli.Command, *Options, []string)(int, error)) {
ans := root.AddSubCommand(&cli.Command{
Name: "themes",
ShortDescription: "Manage kitty color schemes easily",
Usage: "[options] [theme name to switch to]",
HelpText: "Change the kitty theme. If no theme name is supplied, run interactively, otherwise change the current theme to the specified theme name.",
Run: func(cmd *cli.Command, args []string) (int, error) {
opts := Options{}
err := cmd.GetOptionValues(&opts)
if err != nil { return 1, err }
return run_func(cmd, &opts, args)},
})
ans.Add(cli.OptionSpec{
            Name: "--cache-age",
            Type: "float",
            Dest: "CacheAge",
            Help: "Check for new themes only after the specified number of days. A value of zero will always check for new themes. A negative value will never check for new themes, instead raising an error if a local copy of the themes is not available.",
        
	Default: "1",
})
ans.Add(cli.OptionSpec{
            Name: "--reload-in",
            Type: "choices",
            Dest: "ReloadIn",
            Help: "By default, this kitten will signal only the parent kitty instance it is running in to reload its config, after making changes. Use this option to instead either not reload the config at all or in all running kitty instances.",
        
Choices: "parent, all, none",

Completer: cli.NamesCompleter("Choices for reload-in", "parent", "all", "none"),
	Default: "parent",
})
ans.Add(cli.OptionSpec{
            Name: "--dump-theme",
            Type: "bool-set",
            Dest: "DumpTheme",
            Help: "When running non-interactively, dump the specified theme to STDOUT instead of changing kitty.conf.",
        
	Default: "false",
})
ans.Add(cli.OptionSpec{
            Name: "--config-file-name",
            Type: "",
            Dest: "ConfigFileName",
            Help: "The name or path to the config file to edit. Relative paths are interpreted with respect to the kitty config directory. By default the kitty config file, kitty.conf is edited. This is most useful if you add :code:`include themes.conf` to your kitty.conf and then have the kitten operate only on :file:`themes.conf`, allowing :code:`kitty.conf` to remain unchanged.",
        
	Default: "kitty.conf",
})
ans.ArgCompleter = complete_themes
}
type Options struct {
CacheAge float64
ReloadIn string
DumpTheme bool
ConfigFileName string
}
func (opts Options) AsCommandLine() (ans []string) {
	 sval := ""
	 _ = sval
	sval = fmt.Sprintf(`%f`, opts.CacheAge)
	if (sval != `1`) { ans = append(ans, `--cache-age=` + sval)}
	sval = opts.ReloadIn
	if (sval != "parent") { ans = append(ans, `--reload-in=` + sval)}
	sval = fmt.Sprintf(`%#v`, opts.DumpTheme)
	if (sval != `false`) { ans = append(ans, `--dump-theme=` + sval)}
	sval = opts.ConfigFileName
	if (sval != "kitty.conf") { ans = append(ans, `--config-file-name=` + sval)}
return
}
