#include "gl.h"

typedef struct BgimageUniforms {
    GLint image;
    GLint opacity;
    GLint premult;
    GLint tiled;
    GLint sizes;
    GLint positions;
} BgimageUniforms;

static inline void
get_uniform_locations_bgimage(int program, BgimageUniforms *ans) {
    ans->image = get_uniform_location(program, "image");
    ans->opacity = get_uniform_location(program, "opacity");
    ans->premult = get_uniform_location(program, "premult");
    ans->tiled = get_uniform_location(program, "tiled");
    ans->sizes = get_uniform_location(program, "sizes");
    ans->positions = get_uniform_location(program, "positions");
}

typedef struct BorderUniforms {
    GLint viewport;
    GLint colors;
    GLint background_opacity;
    GLint tint_opacity;
    GLint tint_premult;
    GLint gamma_lut;
} BorderUniforms;

static inline void
get_uniform_locations_border(int program, BorderUniforms *ans) {
    ans->viewport = get_uniform_location(program, "viewport");
    ans->colors = get_uniform_location(program, "colors");
    ans->background_opacity = get_uniform_location(program, "background_opacity");
    ans->tint_opacity = get_uniform_location(program, "tint_opacity");
    ans->tint_premult = get_uniform_location(program, "tint_premult");
    ans->gamma_lut = get_uniform_location(program, "gamma_lut");
}

typedef struct CellUniforms {
    GLint sprites;
    GLint text_contrast;
    GLint text_gamma_adjustment;
    GLint gamma_lut;
    GLint sprite_decorations_map;
    GLint draw_bg_bitfield;
    GLint inactive_text_alpha;
    GLint dim_opacity;
} CellUniforms;

static inline void
get_uniform_locations_cell(int program, CellUniforms *ans) {
    ans->sprites = get_uniform_location(program, "sprites");
    ans->text_contrast = get_uniform_location(program, "text_contrast");
    ans->text_gamma_adjustment = get_uniform_location(program, "text_gamma_adjustment");
    ans->gamma_lut = get_uniform_location(program, "gamma_lut");
    ans->sprite_decorations_map = get_uniform_location(program, "sprite_decorations_map");
    ans->draw_bg_bitfield = get_uniform_location(program, "draw_bg_bitfield");
    ans->inactive_text_alpha = get_uniform_location(program, "inactive_text_alpha");
    ans->dim_opacity = get_uniform_location(program, "dim_opacity");
}

typedef struct GraphicsUniforms {
    GLint image;
    GLint amask_fg;
    GLint amask_bg_premult;
    GLint inactive_text_alpha;
    GLint src_rect;
    GLint dest_rect;
    GLint viewport;
} GraphicsUniforms;

static inline void
get_uniform_locations_graphics(int program, GraphicsUniforms *ans) {
    ans->image = get_uniform_location(program, "image");
    ans->amask_fg = get_uniform_location(program, "amask_fg");
    ans->amask_bg_premult = get_uniform_location(program, "amask_bg_premult");
    ans->inactive_text_alpha = get_uniform_location(program, "inactive_text_alpha");
    ans->src_rect = get_uniform_location(program, "src_rect");
    ans->dest_rect = get_uniform_location(program, "dest_rect");
    ans->viewport = get_uniform_location(program, "viewport");
}

typedef struct TintUniforms {
    GLint tint_color;
    GLint edges;
} TintUniforms;

static inline void
get_uniform_locations_tint(int program, TintUniforms *ans) {
    ans->tint_color = get_uniform_location(program, "tint_color");
    ans->edges = get_uniform_location(program, "edges");
}

typedef struct TrailUniforms {
    GLint cursor_edge_x;
    GLint cursor_edge_y;
    GLint trail_color;
    GLint trail_opacity;
    GLint x_coords;
    GLint y_coords;
} TrailUniforms;

static inline void
get_uniform_locations_trail(int program, TrailUniforms *ans) {
    ans->cursor_edge_x = get_uniform_location(program, "cursor_edge_x");
    ans->cursor_edge_y = get_uniform_location(program, "cursor_edge_y");
    ans->trail_color = get_uniform_location(program, "trail_color");
    ans->trail_opacity = get_uniform_location(program, "trail_opacity");
    ans->x_coords = get_uniform_location(program, "x_coords");
    ans->y_coords = get_uniform_location(program, "y_coords");
}
